Drawing Workbench: Difference between revisions

From FreeCAD Documentation
m (add {{cn|Drawing Module/cn}})
(Marked this version for translation)
 
(71 intermediate revisions by 15 users not shown)
Line 1: Line 1:
<languages/>
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!
<translate>


<!--T:69-->
=== GUI Tools ===
{{Docnav
|
|
|IconL=
|IconR=
}}


<!--T:73-->
{{Drawing Tools}}
{{VeryImportantMessage|The '''Drawing Workbench''' is no longer included after version 0.20.<br>
The [[TechDraw_Workbench|TechDraw Workbench]] is its more advanced replacement.}}


<!--T:72-->
[[Image:Workbench_Drawing.svg|thumb|128px|Drawing workbench icon]]


== Introduction == <!--T:64-->
[[Image:Drawing_extraction.png|800px]]


<!--T:1-->
In the picture you see the main concepts of the Drawing module. The document contains a shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The template is an SVG document which can hold your usual page frame, your logo or comply to your presentation standards.
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet.


</translate>
In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes the page gets regenerated and the page display updated.
{{TOCright}}
[[Image:Drawing_extraction.png|600px]]
<translate>


=== Scripting ===
== Tools == <!--T:2-->


<!--T:3-->
At the moment the end user(GUI) workflow is very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.
These are tools for creating, configuring and exporting 2D drawing sheets


<!--T:52-->
==== Simple example ====
* [[Image:Drawing_New.png|32px]] [[Drawing_Open_SVG|Open scalable vector graphic]]: Opens a drawing sheet previously saved as an SVG file


<!--T:53-->
First of all you need the Part and the Drawing module:
* [[Image:Drawing_Landscape_A3.png|32px]] [[Drawing_Landscape_A3|New A3 landscape drawing]]: Creates a new drawing sheet from FreeCAD's default A3 template
import FreeCAD, Part, Drawing
Create a small sample part
Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))
Direct projection. The G0 means hard edge, the G1 is tangent continuous.
Shape = App.ActiveDocument.Shape.Shape
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
print "visible edges:", len(visibleG0.Edges)
print "hidden edges:", len(hiddenG0.Edges)
Everything was projected on the Z-plane:
print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
print "Bnd Box project: X=",visibleG0.BoundBox.XLength," Y=",visibleG0.BoundBox.YLength," Z=",visibleG0.BoundBox.ZLength
Different projection vector
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape,App.Vector(1,1,1))
Project to SVG
resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
print resultSVG


<!--T:54-->
==== The parametric way ====
* [[Image:Drawing_View.png|32px]] [[Drawing_View|Insert a view]]: Inserts a view of the selected object in the active drawing sheet


<!--T:55-->
Create the body
* [[Image:Drawing_Annotation.png|32px]] [[Drawing_Annotation|Annotation]]: Adds an annotation to the current drawing sheet
# Create three boxes and a cylinder
App.ActiveDocument.addObject("Part::Box","Box")
App.ActiveDocument.Box.Length=100.00
App.ActiveDocument.Box.Width=100.00
App.ActiveDocument.Box.Height=100.00
App.ActiveDocument.addObject("Part::Box","Box1")
App.ActiveDocument.Box1.Length=90.00
App.ActiveDocument.Box1.Width=40.00
App.ActiveDocument.Box1.Height=100.00
App.ActiveDocument.addObject("Part::Box","Box2")
App.ActiveDocument.Box2.Length=20.00
App.ActiveDocument.Box2.Width=85.00
App.ActiveDocument.Box2.Height=100.00
App.ActiveDocument.addObject("Part::Cylinder","Cylinder")
App.ActiveDocument.Cylinder.Radius=80.00
App.ActiveDocument.Cylinder.Height=100.00
App.ActiveDocument.Cylinder.Angle=360.00
# Fuse two boxes and the cylinder
App.activeDocument().addObject("Part::Fuse","Fusion")
App.activeDocument().Fusion.Base = App.activeDocument().Cylinder
App.activeDocument().Fusion.Tool = App.activeDocument().Box1
App.activeDocument().addObject("Part::Fuse","Fusion1")
App.activeDocument().Fusion1.Base = App.activeDocument().Box2
App.activeDocument().Fusion1.Tool = App.activeDocument().Fusion
# Cut the fused shapes from the first box
App.activeDocument().addObject("Part::Cut","Shape")
App.activeDocument().Shape.Base = App.activeDocument().Box
App.activeDocument().Shape.Tool = App.activeDocument().Fusion1
# Hide all the intermediate shapes
Gui.activeDocument().Box.Visibility=False
Gui.activeDocument().Box1.Visibility=False
Gui.activeDocument().Box2.Visibility=False
Gui.activeDocument().Cylinder.Visibility=False
Gui.activeDocument().Fusion.Visibility=False
Gui.activeDocument().Fusion1.Visibility=False


<!--T:56-->
Insert a Page object and assign a template
* [[Image:Drawing_Clip.png|32px]] [[Drawing_Clip|Clip]]: Adds a clip group to the current drawing sheet
App.activeDocument().addObject('Drawing::FeaturePage','Page')
App.activeDocument().Page.Template = App.getResourceDir()+'Mod/Drawing/Templates/A3_Landscape.svg'


<!--T:57-->
Create a view on the "Shape" object, define the position and scale and assign it to a Page
* [[Image:Drawing_Openbrowser.png|32px]] [[Drawing_Openbrowser|Open Browser]]: Opens a preview of the current sheet in the browser
App.activeDocument().addObject('Drawing::FeatureViewPart','View')
App.activeDocument().View.Source = App.activeDocument().Shape
App.activeDocument().View.Direction = (0.0,0.0,1.0)
App.activeDocument().View.X = 10.0
App.activeDocument().View.Y = 10.0
App.activeDocument().Page.addObject(App.activeDocument().View)


<!--T:58-->
Create a second view on the same object but this time the view will be rotated by 90 degrees.
* [[Image:Drawing_Orthoviews.png|32px]] [[Drawing_Orthoviews|Ortho Views]]: Automatically creates orthographic views of an object on the current drawing sheet
App.activeDocument().addObject('Drawing::FeatureViewPart','ViewRot')
App.activeDocument().ViewRot.Source = App.activeDocument().Shape
App.activeDocument().ViewRot.Direction = (0.0,0.0,1.0)
App.activeDocument().ViewRot.X = 290.0
App.activeDocument().ViewRot.Y = 30.0
App.activeDocument().ViewRot.Scale = 1.0
App.activeDocument().ViewRot.Rotation = 90.0
App.activeDocument().Page.addObject(App.activeDocument().ViewRot)


<!--T:59-->
Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.
* [[Image:Drawing_Symbol.png|32px]] [[Drawing_Symbol|Symbol]]: Adds the contents of a SVG file as a symbol on the current drawing sheet
App.activeDocument().addObject('Drawing::FeatureViewPart','ViewIso')
App.activeDocument().ViewIso.Source = App.activeDocument().Shape
App.activeDocument().ViewIso.Direction = (1.0,1.0,1.0)
App.activeDocument().ViewIso.X = 335.0
App.activeDocument().ViewIso.Y = 140.0
App.activeDocument().ViewIso.ShowHiddenLines = True
App.activeDocument().Page.addObject(App.activeDocument().ViewIso)
Change something and update. The update process changes the view and the page.
App.activeDocument().View.X = 30.0
App.activeDocument().View.Y = 30.0
App.activeDocument().View.Scale = 1.5
App.activeDocument().recompute()


<!--T:60-->
==== Accessing the bits and pieces ====
* [[Image:Drawing_DraftView.png|32px]] [[Draft_Drawing|Draft View]]: Inserts a special Draft view of the selected object in the current drawing sheet


<!--T:61-->
Get the SVG fragment of a single view
* [[Image:Drawing_SpreadsheetView.png|32px]] [[Drawing_SpreadsheetView|Spreadsheet View]]: Inserts a view of a selected spreadsheet in the current drawing sheet
ViewSVG = App.activeDocument().View.ViewResult
print ViewSVG
Get the whole result page (it's a file in the document's temporary directory, only read permission)
print "Resulting SVG document: ",App.activeDocument().Page.PageResult
file = open(App.activeDocument().Page.PageResult,"r")
print "Result page is ",len(file.readlines())," lines long"


<!--T:62-->
Important: free the file!
* [[Image:Drawing_Save.png|32px]] [[Drawing_Save|Save sheet]]: Saves the current sheet as a SVG file
del file
Insert a view with your own content:
App.activeDocument().addObject('Drawing::FeatureView','ViewSelf')
App.activeDocument().ViewSelf.ViewResult = """<g id="ViewSelf"
stroke="rgb(0, 0, 0)"
stroke-width="0.35"
stroke-linecap="butt"
stroke-linejoin="miter"
transform="translate(30,30)"
fill="#00cc00"
>
<ellipse cx="40" cy="40" rx="30" ry="15"/>
</g>
"""
App.activeDocument().Page.addObject(App.activeDocument().ViewSelf)
App.activeDocument().recompute()
del Shape,ViewSVG, resultSVG
That leads to the following result:


<!--T:63-->
[[Image:DrawingScriptResult.jpg|800px]]
* [[Drawing_ProjectShape|Project Shape]]: Creates a projection of the selected object (Source) in the 3D view.


<!--T:4-->
==== General Dimensioning and Tolerancing ====
* {{Emphasis|Note:}} the [[Draft Drawing|Draft Drawing]] tool is used with [[Draft Workbench|Draft objects]]. It has some additional capabilities over the Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].


<!--T:6-->
Drawing dimensions an toleranecs are still under development but you can get some basic functionality with a bit of work.
== Workflow ==
The document contains a 3D shape object (leg) from which we want to produce a drawing. Therefore a "Page" is created. A page it's instantiated from a template, for example, the "A3_Landscape" template. The template is an [[SVG|SVG]] document which can hold a page frame, a logo, and other elements.


<!--T:7-->
First you need to get the gdtsvg python module from here (WARNING: This could be broken at any time!):
In this page we can insert one or more views. Each view has a position on the page, a scale factor, and additional properties. Every time the page or the view or the referenced object changes, the page is regenerated and the page display updated.


== Scripting == <!--T:8-->
https://github.com/jcc242/FreeCAD


<!--T:9-->
To get a feature control frame, try out the following:
At the moment the graphical user interface workflow is very limited, so the scripting API is more interesting.


<!--T:65-->
import gdtsvg as g # Import the module, I like to give it an easy handle
See the [[Drawing API example]] page for a description of the functions used to create drawing pages and views.
ourFrame = g.ControlFrame("0","0", g.Perpendicularity(), ".5", g.Diameter(), g.ModifyingSymbols("M"), "A", g.ModifyingSymbols("F"), "B", g.ModifyingSymbols("L"), "C", g.ModifyingSymbols("I"))
<nowiki>'''</nowiki>Here is a good breakdown of the contents of a feature control frame: [http://www.cadblog.net/adding-geometric-tolerances.htm]<nowiki>'''</nowiki>


== Templates == <!--T:43-->
The parameters to pass to control frame are:
#X-coordinate in SVG-coordinate system (type string)
#Y-coordinate in SVG-coordinate system (type string)
#The desired geometric characteristic symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
#The tolerance (type string)
#(optional) The diameter symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The condition modifying material (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The first datum (type string)
#(optional) The first datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The second datum (type string)
#(optional) The second datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The third datum (type string)
#(optional) The third datum's material condition (tuple, svg string as first, width of symbol as second, height of symbol as third)


<!--T:44-->
The ControlFrame function returns a type containing (svg string, overall width of control frame, overall height of control frame)'''
FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.


== Extending the Drawing Module == <!--T:45-->
To get a dimension, try out the following:


<!--T:46-->
import gdtsvg
Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.
ourDimension = linearDimension(point1, point2, textpoint, dimensiontext, linestyle=getStyle("visible"), arrowstyle=getStyle("filled"), textstyle=getStyle("text")


<!--T:49-->
Inputs for linear dimension are:
== Tutorials ==
#point1, an (x,y) tuple with svg-coordinates, this is one of the points you would like to dimension between
* [[Drawing_tutorial|Drawing tutorial]]
#point2, an (x,y) tuple with svg-coordinates, this is the second point you would like to dimension between
* [[Drawing_Template_HowTo|Drawing Template HowTo]]
#textpoint, an (x,y) tuple of svg-coordinates, this is where the text of your dimension will be
#dimensiontext, a string containing the text you want the dimension to say
#linestyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling the how the lines look
#arrowstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the arrows look
#textstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the text looks


== Macros == <!--T:74-->
With those two, you can proceed as above for displaying them on the drawing page. This module is very buggy and can be broken at any given moment, bug reports are welcome on the github page for now, or contact jcc242 on the forums if you post a bug somewhere else.


<!--T:75-->
=== Templates ===
* {{MacroLink|Icon=Macro_Automatic_drawing.png|Macro_Automatic_drawing|Macro Automatic drawing}}: Allows the user to get the view of his object in a drawing with 4 different position (front,top,iso,right). Needs some modification to be perfectly effective.


<!--T:76-->
FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.
* {{MacroLink|Icon=Macro_CartoucheFC.png|Macro_CartoucheFC|Macro CartoucheFC}}: This GUI macro to fill simply all fields of the cartridge of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.


<!--T:77-->
=== Extending Drawing Module ===
* {{MacroLink|Icon=Macro_CartoucheFC_2.png|Macro_CartoucheFC_2|Macro CartoucheFC 2}}: This GUI macro to fill simply all fields of the cartridge '''model 2''' of the plan implementation worksheet FreeCAD.


<!--T:78-->
Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.
* {{MacroLink|Icon=Macro_CartoucheFC_Full.png|Macro_CartoucheFC_Full|Macro CartoucheFC Full}}: This GUI macro to fill simply all fields of the cartridge [[Misc_templates_Full|Misc templates Full]] of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.

<!--T:79-->
* {{MacroLink|Icon=Macro_Corner_shapes_wizard.png|Macro_Corner_shapes_wizard/update|Macro Corner shapes wizard/update}}: Pops up a dialog asking for the dimensions of your corner piece, then creates the object in the document and creates a page view with top, front and lateral views of the piece.

== External links == <!--T:80-->

<!--T:50-->
* [https://www.youtube.com/watch?v=1Hm5Zyjmjac Intro to mechanical drawing on Youtube - by Normal Universe]


{{docnav|Part Module|Robot Module}}


<!--T:47-->
{{languages |{{cn|Drawing Module/cn}} {{de|Drawing Module/de}} {{es|Drawing Module/es}} {{fr|Drawing Module/fr}} {{it|Drawing Module/it}} {{jp|Drawing Module/jp}} {{pl|Drawing Module/pl}} {{ru|Drawing Module/ru}} {{se|Drawing Module/se}} }}
{{Docnav
|
|
|IconL=
|IconR=
}}


</translate>
[[Category:User Documentation]]
{{Drawing Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
[[Category:Obsolete Workbenches{{#translation:}}]]

Latest revision as of 08:46, 8 July 2023

The Drawing Workbench is no longer included after version 0.20.
The TechDraw Workbench is its more advanced replacement.
Drawing workbench icon

Introduction

The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet.

Tools

These are tools for creating, configuring and exporting 2D drawing sheets

  • Insert a view: Inserts a view of the selected object in the active drawing sheet
  • Annotation: Adds an annotation to the current drawing sheet
  • Clip: Adds a clip group to the current drawing sheet
  • Open Browser: Opens a preview of the current sheet in the browser
  • Ortho Views: Automatically creates orthographic views of an object on the current drawing sheet
  • Symbol: Adds the contents of a SVG file as a symbol on the current drawing sheet
  • Draft View: Inserts a special Draft view of the selected object in the current drawing sheet
  • Spreadsheet View: Inserts a view of a selected spreadsheet in the current drawing sheet
  • Save sheet: Saves the current sheet as a SVG file
  • Project Shape: Creates a projection of the selected object (Source) in the 3D view.

Workflow

The document contains a 3D shape object (leg) from which we want to produce a drawing. Therefore a "Page" is created. A page it's instantiated from a template, for example, the "A3_Landscape" template. The template is an SVG document which can hold a page frame, a logo, and other elements.

In this page we can insert one or more views. Each view has a position on the page, a scale factor, and additional properties. Every time the page or the view or the referenced object changes, the page is regenerated and the page display updated.

Scripting

At the moment the graphical user interface workflow is very limited, so the scripting API is more interesting.

See the Drawing API example page for a description of the functions used to create drawing pages and views.

Templates

FreeCAD comes bundled with a set of default templates, but you can find more on the Drawing templates page.

Extending the Drawing Module

Some notes on the programming side of the drawing module will be added to the Drawing Documentation page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.

Tutorials

Macros

  • Macro Automatic drawing: Allows the user to get the view of his object in a drawing with 4 different position (front,top,iso,right). Needs some modification to be perfectly effective.
  • Macro CartoucheFC: This GUI macro to fill simply all fields of the cartridge of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
  • Macro CartoucheFC 2: This GUI macro to fill simply all fields of the cartridge model 2 of the plan implementation worksheet FreeCAD.
  • Macro CartoucheFC Full: This GUI macro to fill simply all fields of the cartridge Misc templates Full of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
  • Macro Corner shapes wizard/update: Pops up a dialog asking for the dimensions of your corner piece, then creates the object in the document and creates a page view with top, front and lateral views of the piece.

External links